-- #####################################################################################
-- ## Skript zum Vortrag <die schwierigen Kopfnsse mit T-SQL gelst>                 ##     
-- #####################################################################################
-- ## Dieses Skript legt die Prozeduren fr die Aufgabe OKTOBERFEST an. Es wird durch ##
-- ## weitere Skripte ergnzt, die in ihrer durchnummerierten Reihenfolge abzu-       ##
-- ## arbeiten sind. Die Skripte passen zu den Ausfhrungen aus der zugehrigen       ##
-- ## Powerpoint-Prsentation vom selben Autor.                                       ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Bitte dieses Skript niemals in einer Produktionsumgebung einsetzen, da          ##
-- ## Datenbankobjekte angelegt, ergnzt, gendert oder sogar gelscht werden!!!      ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Verwendung auf eigene Gefahr...                                                 ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Torsten Ahlemeyer, arelium GmbH        torsten.ahlemeyer@arelium.de             ##
-- #####################################################################################

-- auf die Projektdatenbank wechseln
USE [Workshop_Kopfnuesse]

SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

-----------------------------
-- Aufbauarbeiten ----------
-----------------------------

-- Prozedur SPASSGELDAUSGEBEN im Schema OKTOBERFEST anlegen
CREATE OR ALTER PROCEDURE [Oktoberfest].[SpassgeldAusgeben]
	  @ZielPreis				MONEY
	, @ProzentualeAbweichung	INTEGER
AS
BEGIN
	SET NOCOUNT ON;
;WITH loopquery
(
	  [Letzte_id]
	, [Kosten]
	, [AnzahlAktionen]
	, [Attraktionen]
) 
AS (
	-- Initialisierung der Rekursion
	SELECT 
		  [att].[ID]									AS [ID]
		, [att].[Preis]									AS [Preis]
		, 1												AS [AnzahlAktionen]
		, CAST([att].[Attraktion] AS VARCHAR(MAX))		AS [Attraktionen]
	FROM [Oktoberfest].[Attraktion]						AS [att]
	
	UNION ALL
	
	-- Rekursion mit der Summierung der Attraktionsanzahl und des Preises
	SELECT 
		  [p].ID
		, [lq].[Kosten] + [p].[Preis]
		, [AnzahlAktionen] + 1
		, CAST([lq].[Attraktionen] + ', ' + [p].[Attraktion] AS VARCHAR(MAX))
	FROM loopquery										AS [lq]
	INNER JOIN [Oktoberfest].[Attraktion] AS [p] ON [p].[ID] >= [lq].[Letzte_id]
	WHERE 1 = 1
		-- Abbruchbedingung der Rekursion
		AND [lq].[Kosten] + [p].[Preis] <= @ZielPreis
	)

	-- Ausgabe des Ergebnisses
	SELECT --TOP 1 WITH TIES
		  @ZielPreis												AS [Zielpreis] 
		, [Kosten] 
		, [AnzahlAktionen]
		, [Attraktionen]
	FROM loopquery
	WHERE 1=1
		AND [Kosten] >= ((@ZielPreis / 100) * (100 - @ProzentualeAbweichung))
	ORDER BY [Kosten] DESC, [AnzahlAktionen] ASC
	END
GO

-- ### Hinweis: ###
-- Ein-/Auskommentiertes "TOP 1 WITH TIES" beeinflusst, ob gleichwertige bestplatzierte oder nur genau eine 
-- bestplatzierte Lsung angezeigt werden sollen
