-- #####################################################################################
-- ## Skript zum Vortrag <die schwierigen Kopfnsse mit T-SQL gelst - Version 2.0>   ##     
-- #####################################################################################
-- ## Dieses Skript zeigt den Weg, wie ein gegebenes Sudoku Die                       ##
-- ## Skripte passen zu den Aufgabenstellungen aus der zugehrigen Powerpoint-        ##
-- ## Prsentation vom selben Autor.                                                  ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Bitte dieses Skript niemals in einer Produktionsumgebung einsetzen, da          ##
-- ## Datenbankobjekte angelegt, ergnzt, gendert oder sogar gelscht werden!!!      ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Verwendung auf eigene Gefahr...                                                 ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Torsten Ahlemeyer, arelium GmbH        torsten.ahlemeyer@arelium.de             ##
-- #####################################################################################

-- "richtige" Datenbank auswhlen
USE [Workshop_Kopfnuesse]
GO

-----------------------------
-- Aufrumarbeiten ----------
-----------------------------

IF OBJECT_ID('[Sudoku].[spSudokuLoesen]', 'P') IS NOT NULL
	DROP PROCEDURE [Sudoku].[spSudokuLoesen];
GO



-----------------------------
-- Aufbauarbeiten ----------
-----------------------------
-- Hier wird ein Sudokufeld regelkonform gefllt
CREATE OR ALTER  PROCEDURE [Sudoku].[spSudokuLoesen]
	@VorgabeSudoku	VARCHAR(100)
AS
BEGIN
	DECLARE @SudokuNo		INTEGER			= 1					
	DECLARE @SudokuMatrix	Table (RowCol Int Primary Key Clustered, ConcatRow varchar(10))
 
	--das Sudoku lsen - in Stringform
	;WITH dual(N) AS 
		(SELECT ROW_NUMBER() OVER (ORDER BY (SELECT N)) 
		FROM ( VALUES(1),(2),(3),(4),(5),(6),(7),(8),(9)) x(N)), x( s, ind ) AS
		( SELECT @VorgabeSudoku, CHARINDEX(' ',@VorgabeSudoku ) AS ind
  
	  UNION ALL
  
	  SELECT CONVERT(VARCHAR(100), SUBSTRING( s, 1, ind - 1 ) + z + SUBSTRING( s, ind + 1 ,81))
		   , CHARINDEX( ' ', s, ind + 1 ) AS ind
	  FROM x
		CROSS APPLY (
						SELECT CONVERT(VARCHAR(25), N ) z
						 FROM dual
						 WHERE 1=1
							AND N <= 9
		   ) z (z)
	  WHERE 1=1
		AND ind > 0
		AND NOT EXISTS 
			(SELECT NULL FROM (
								SELECT N AS lp
								FROM dual
								WHERE 1=1
									AND N <= 9
							) ww (lp)
						WHERE z = SUBSTRING( s, ( ind - 1)% 9  - 8 + lp * 9, 1 )
							OR    z = SUBSTRING( s, ( ( ind - 1 ) / 9 ) * 9 + lp, 1 )
							OR    z = SUBSTRING( s, (( ( ind - 1 ) / 3 )%3) * 3
										  + ( ( ind - 1 ) / 27 ) * 27 + lp
										  + ( ( lp - 1 ) / 3 ) * 6
									   , 1 )
					 )
	), Sud as (
	
	-- ein Recordset mit 9 Ergebnisreihen erstellen und fr die Lsung 8 mal duplizieren. Es werden dann nur jeweils die passenden Teilstrings angezeigt
	select TOP 9 SUBSTRING(s, ROW_NUMBER() OVER (ORDER BY s) * 9 - 8, ROW_NUMBER() OVER (ORDER BY s) * 9 - (ROW_NUMBER() OVER (ORDER BY s) * 9 - 9)) as ConcatRow
	FROM x
	CROSS APPLY ( VALUES(1),(2),(3),(4),(5),(6),(7),(8),(9)) y(N)
	WHERE ind = 0
	)
 
	--Tabellenvariable fr weitere Manipulationen nutzen
	INSERT INTO @SudokuMatrix (RowCol,ConcatRow)
		SELECT Row_Number() OVER (ORDER BY (SELECT 1)), ConcatRow
			FROM Sud
 
	-- ber eine Pivot-Funktion eine Lsungs-Matrix generieren
	SELECT @SudokuNo AS SudokuNo,c1.RowCol,[1],[2],[3],[4],[5],[6],[7],[8],[9]
		FROM @SudokuMatrix S
		CROSS APPLY (SELECT RowCol,[1],[2],[3],[4],[5],[6],[7],[8],[9]
						FROM (SELECT S.RowCol
								,ColNo = Row_Number() OVER (PARTITION BY RowCol ORDER BY ConcatRow)
								,DATA = SUBSTRING(ConcatRow, ROW_NUMBER() OVER (PARTITION BY S.RowCol ORDER BY ConcatRow), 1)
						FROM @SudokuMatrix S
							CROSS APPLY ( VALUES(1),(2),(3),(4),(5),(6),(7),(8),(9)) x(N)
							) Intr
							PIVOT (
							MAX(Data)
							FOR ColNo IN ([1],[2],[3],[4],[5],[6],[7],[8],[9])
			) PVT) AS C1
		WHERE c1.RowCol = S.RowCol
		ORDER BY S.RowCol ASC
END
GO
