-- #####################################################################################
-- ## Skript zum Vortrag <die schwierigen Kopfnsse mit T-SQL gelst - Version 2.0>   ##     
-- #####################################################################################
-- ## Dieses Skript legt die Objekte zru Aufgabe "Grillgutkette" an. Es wird durch    ##
-- ## weitere Skripte ergnzt, die in ihrer durchnummerierten Reihenfolge             ##
-- ## abzuarbeiten sind. Die Skripte passen zu den Aufgabenstellungen aus der         ##
-- ## zugehrigen Powerpoint-Prsentation vom selben Autor.                           ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Bitte dieses Skript niemals in einer Produktionsumgebung einsetzen, da          ##
-- ## Datenbankobjekte angelegt, ergnzt, gendert oder sogar gelscht werden!!!      ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Verwendung auf eigene Gefahr...                                                 ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Torsten Ahlemeyer, arelium GmbH        torsten.ahlemeyer@arelium.de             ##
-- #####################################################################################

-- "richtige" Datenbank auswhlen
USE [Workshop_Kopfnuesse]
GO

SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

-----------------------------
-- Aufrumarbeiten ----------
-----------------------------

-- bestehende Sicht VGRILLGUT im Schema KETTE lschen, um sauber wieder aufzusetzen
DROP VIEW [Kette].[vGrillgut]

-- bestehende Funktion ABFLACHEN im Schema KETTE lschen, um sauber wieder aufzusetzen
DROP FUNCTION IF EXISTS [Kette].[Abflachen]

-- bestehende Tabelle GRILLGUT im Schema KETTE lschen, um sauber wieder aufzusetzen
DROP TABLE IF EXISTS [Kette].[Grillgut]
GO

-- bestehendes Schema KETTE lschen, um sauber wieder aufzusetzen
DROP SCHEMA  IF EXISTS [Kette]
GO


-----------------------------
-- Aufbauarbeiten ----------
-----------------------------
-- Schema KETE anlegen, um Objekte sauber der Aufgabe zuordnen zu knnen
CREATE SCHEMA [Kette]
GO

-- Tabelle GRILLGUT im Schema KETTE anlegen
CREATE TABLE [Kette].[Grillgut](
	  [ID]			[INT] PRIMARY KEY IDENTITY(1,1)
	, [GastName]	[NVARCHAR](25)							NOT NULL
	, [Bezeichnung]	[NVARCHAR](30)							NOT NULL
	, [Anzahl]		[TINYINT]								NOT NULL
) ON [PRIMARY]
GO

-- Tabelle Grillgut im Schema Kette mit den Inhalten aus der Powerpoint-Prsentation fllen
INSERT INTO [Kette].[Grillgut] VALUES 
    ('Peter',	'Wrstchen',	4)
  , ('Monika',  'Wrstchen',	2)
  , ('Frank',	'Wrstchen',	3)
  , ('Sonja',	'Wrstchen',	1)

  , ('Peter',	'Steak(s)',		1)
  , ('Monika',	'Steak(s)',		1)
  , ('Frank',	'Steak(s)',		2)

  , ('Sonja',	'Maiskolben',	2)
  , ('Peter',	'Maiskolben',	1)
 GO

 CREATE VIEW [Kette].[vGrillgut]
 AS

	 SELECT 
		[GastName]													AS [GastName]
		, CONVERT(VARCHAR(2), [Anzahl]) + ' ' + [Bezeichnung]		AS [Grillgut]
	FROM  [Kette].[Grillgut]
 GO