-- #####################################################################################
-- ## Skript zum Vortrag <die schwierigen Kopfnsse mit T-SQL gelst>                 ##     
-- #####################################################################################
-- ## Dieses Skript legt die Tabellen fr die Aufgabe EINSTEIN an. Es wird durch      ##
-- ## weitere Skripte ergnzt, die in ihrer durchnummerierten Reihenfolge abzu-       ##
-- ## arbeiten sind. Die Skripte passen zu den Ausfhrungen aus der zugehrigen       ##
-- ## Powerpoint-Prsentation vom selben Autor.                                       ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Bitte dieses Skript niemals in einer Produktionsumgebung einsetzen, da          ##
-- ## Datenbankobjekte angelegt, ergnzt, gendert oder sogar gelscht werden!!!      ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Verwendung auf eigene Gefahr...                                                 ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Torsten Ahlemeyer, arelium GmbH        torsten.ahlemeyer@arelium.de             ##
-- #####################################################################################

-- auf die Projektdatenbank wechseln
USE [Workshop_Kopfnuesse]
GO

SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO





-- ########################################################################
-- ### Vergleich der Worte "Maus" und "Maus" ##############################
-- ### Erwartet wird eine Levenshteindistanz von 0 ########################
-- ########################################################################
SELECT [Levenshtein].[Levenshtein] (
    'Maus'								-- Wort 1
  , 'Maus'								-- Wort 2
  , 100)								-- erlaubes Maximum an Abweichungen
  AS [Levenshtein-Abweichung]
GO



-- ########################################################################
-- ### Vergleich der Worte "Maus" und "Haus" ##############################
-- ### Erwartet wird eine Levenshteindistanz von 1 ########################
-- ########################################################################
SELECT [Levenshtein].[Levenshtein] (
    'Maus'								-- Wort 1
  , 'Haus'								-- Wort 2
  , 100)								-- erlaubes Maximum an Abweichungen
  AS [Levenshtein-Abweichung]
GO



-- ########################################################################
-- ### Vergleich der Worte "Maut" und "Haus" ##############################
-- ### Erwartet wird eine Levenshteindistanz von 2 ########################
-- ########################################################################
SELECT [Levenshtein].[Levenshtein] (
    'Maut'								-- Wort 1
  , 'Haus'								-- Wort 2
  , 100)								-- erlaubes Maximum an Abweichungen
  AS [Levenshtein-Abweichung]
GO

-- ########################################################################
-- ### Vergleich der Worte "Frosch" und "Pferd" ###########################
-- ### Erwartet wird eine Levenshteindistanz von 6 ########################
-- ########################################################################
SELECT [Levenshtein].[Levenshtein] (
    'Frosch'							-- Wort 1
  , 'Pferd'								-- Wort 2
  , 100)								-- erlaubes Maximum an Abweichungen
  AS [Levenshtein-Abweichung]
GO

-- ########################################################################
-- ### Vergleich der Worte "Frosch" und (NULL) ############################
-- ### Erwartet wird eine Levenshteindistanz von 6 ########################
-- ########################################################################
SELECT [Levenshtein].[Levenshtein] (
    'Frosch'							-- Wort 1
  , NULL								-- Wort 2
  , 100)								-- erlaubes Maximum an Abweichungen
  AS [Levenshtein-Abweichung]
GO

-- ########################################################################
-- ### Vergleich der Worte "Nrnberg" und "Duisburg" ######################
-- ### hier wird das Maximum aber knstlich begrenzt ######################
-- ### Erwartet wird eine Levenshteindistanz von NULL #####################
-- ########################################################################
SELECT [Levenshtein].[Levenshtein] (
    'Nrnberg'							-- Wort 1
  , 'Duisburg'							-- Wort 2
  , 2)									-- erlaubes Maximum an Abweichungen
  AS [Levenshtein-Abweichung]
GO
