-- #####################################################################################
-- ## Skript zum Vortrag <die schwierigen Kopfnsse mit T-SQL gelst>                 ##     
-- #####################################################################################
-- ## Dieses Skript legt die Tabellen fr die Aufgabe "RubiksCube" an. Es wird durch  ##
-- ## weitere Skripte ergnzt, die in ihrer durchnummerierten Reihenfolge abzu-       ##
-- ## arbeiten sind. Die Skripte passen zu den Ausfhrungen aus der zugehrigen       ##
-- ## Powerpoint-Prsentation vom selben Autor.                                       ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Bitte dieses Skript niemals in einer Produktionsumgebung einsetzen, da          ##
-- ## Datenbankobjekte angelegt, ergnzt, gendert oder sogar gelscht werden!!!      ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Verwendung auf eigene Gefahr...                                                 ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Torsten Ahlemeyer, arelium GmbH        torsten.ahlemeyer@arelium.de             ##
-- #####################################################################################

-- auf die Projektdatenbank wechseln
USE [Workshop_Kopfnuesse]
GO

SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO






/*
        o-----------o-----------o				           o-----------o-----------o
       /           /           /|				          /           /           /|
      /     W     /     W     /	|				         /     W     /     W     / |
     /           /           /	|				        /           /           /  |
	o-----------o-----------o   |				   	   o-----------o-----------o   |
   /	       /	       /| R |				      /	          /	          /| Y |
  /		W     /	    W     /	|  	o				     /		W    /	    W    / |   o
 /           /	         /	|  /|		   \\	    /           /	        /  |  /|	
o-----------o-----------o   | /	|	  ======	   o-----------o-----------o   | / |	
|           |           |	|/	|		   //      |           |           |   |/  |	
|           |           | R |  	|				   |           |           | Y |   |
|     G     |     G     |  /| R |				   |     R     |     R     |  /| R |
|           |           | /	|   o				   |           |           | / |   o
|           |           |/	|  /				   |           |           |/  |  /
o-----------o-----------o   | /					   o-----------o-----------o   | /
|           |           | R |/					   |           |           | R |/
|           |           |   o					   |           |           |   o
|     G     |     G     |  /					   |     G     |     G     |  /
|           |           | /						   |           |           | /
|           |           |/						   |           |           |/
o-----------------------o						   o-----------------------o

*/

-- -----------------------------------------------------------------------------------
-- Diese Funktion nimmt eine Wrfel-ID entgegen, dreht dann genau eine definierte   --
-- Ebene um 90 in die spezifizierte Richtung, generiert eine passende ID und gibt  --
-- die neue Wrfel-ID wieder aus.                                                   --
-- -----------------------------------------------------------------------------------
-- Funktion fr die Drehung der oberen waagerechten Ebene gegen den Uhrzeigersinn   --
-- -----------------------------------------------------------------------------------
CREATE OR ALTER FUNCTION [RubiksCube].[fncDreheObenLinks] 
(
       @Eingangsposition          AS     VARCHAR(24)
)
RETURNS CHAR(24)
AS
BEGIN
    DECLARE @Rueckgabewert		AS VARCHAR(24) = ''
    SET @Rueckgabewert =                    SUBSTRING ( @Eingangsposition ,  2,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  4,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  1,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  3,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 11,  2)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  5,  6)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 13, 12)
    RETURN @Rueckgabewert
END
GO





/*
        o-----------o-----------o				           o-----------o-----------o
       /           /           /|				          /           /           /|
      /     W     /     W     /	|				         /     W     /     W     / |
     /           /           /	|				        /           /           /  |
	o-----------o-----------o   |				   	   o-----------o-----------o   |
   /	       /	       /| R |				      /	          /	          /| G |
  /		W     /	    W     /	|  	o				     /		W    /	    W    / |   o
 /           /	         /	|  /|		   \\	    /           /	        /  |  /|	
o-----------o-----------o   | /	|	  ======	   o-----------o-----------o   | / |	
|           |           |	|/	|		   //      |           |           |   |/  |	
|           |           | R |  	|				   |           |           | G |   |
|     G     |     G     |  /| R |				   |     B     |     B     |  /| R |
|           |           | /	|   o				   |           |           | / |   o
|           |           |/	|  /				   |           |           |/  |  /
o-----------o-----------o   | /					   o-----------o-----------o   | /
|           |           | R |/					   |           |           | R |/
|           |           |   o					   |           |           |   o
|     G     |     G     |  /					   |     G     |     G     |  /
|           |           | /						   |           |           | /
|           |           |/						   |           |           |/
o-----------------------o						   o-----------------------o

*/

-- -----------------------------------------------------------------------------------
-- Diese Funktion nimmt eine Wrfel-ID entgegen, dreht dann genau eine definierte   --
-- Ebene um 90 in die spezifizierte Richtung, generiert eine passende ID und gibt  --
-- die neue Wrfel-ID wieder aus.                                                   --
-- -----------------------------------------------------------------------------------
-- Funktion fr die Drehung der oberen waagerechten Ebene im Uhrzeigersinn          --
-- -----------------------------------------------------------------------------------
CREATE OR ALTER FUNCTION [RubiksCube].[fncDreheObenRechts] 
(
       @Eingangsposition          AS     VARCHAR(24)
)
RETURNS CHAR(24)
AS
BEGIN
    DECLARE @Rueckgabewert     AS VARCHAR(24) = ''
    SET @Rueckgabewert =                    SUBSTRING ( @Eingangsposition ,  3,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  1,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  4,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  2,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  7,  2)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  9,  2)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 11,  2)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  5,  2)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 13, 12)
    RETURN @Rueckgabewert
END
GO




/*
        o-----------o-----------o				           o-----------o-----------o
       /           /           /|				          /           /           /|
      /     W     /     W     /	|				         /     W     /     W     / |
     /           /           /	|				        /           /           /  |
	o-----------o-----------o   |				   	   o-----------o-----------o   |
   /	       /	       /| R |				      /	          /	          /| R |
  /		W     /	    W     /	|  	o				     /		W    /	    W    / |   o
 /           /	         /	|  /|		   \\	    /           /	        /  |  /|	
o-----------o-----------o   | /	|	  ======	   o-----------o-----------o   | / |	
|           |           |	|/	|		   //      |           |           |   |/  |	
|           |           | R |  	|				   |           |           | R |   |
|     G     |     G     |  /| R |				   |     B     |     B     |  /| Y |
|           |           | /	|   o				   |           |           | / |   o
|           |           |/	|  /				   |           |           |/  |  /
o-----------o-----------o   | /					   o-----------o-----------o   | /
|           |           | R |/					   |           |           | Y |/
|           |           |   o					   |           |           |   o
|     G     |     G     |  /					   |     R     |     R     |  /
|           |           | /						   |           |           | /
|           |           |/						   |           |           |/
o-----------------------o						   o-----------------------o

*/

-- -----------------------------------------------------------------------------------
-- Diese Funktion nimmt eine Wrfel-ID entgegen, dreht dann genau eine definierte   --
-- Ebene um 90 in die spezifizierte Richtung, generiert eine passende ID und gibt  --
-- die neue Wrfel-ID wieder aus.                                                   --
-- -----------------------------------------------------------------------------------
-- Funktion fr die Drehung der unteren waagerechten Ebene gegen den Uhrzeigersinn  --
-- -----------------------------------------------------------------------------------
CREATE OR ALTER FUNCTION [RubiksCube].[fncDreheUntenLinks] 
(
       @Eingangsposition          AS     VARCHAR(24)
)
RETURNS CHAR(24)
AS
BEGIN
                DECLARE @Rueckgabewert     AS VARCHAR(24) = ''
                SET @Rueckgabewert =                    SUBSTRING ( @Eingangsposition ,  1, 12)
                SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 15,  6)
                SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 13,  2)
                SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 22,  1)
                SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 24,  1)
                SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 21,  1)
                SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 23,  1)
    RETURN @Rueckgabewert
END
GO



/*
        o-----------o-----------o				           o-----------o-----------o
       /           /           /|				          /           /           /|
      /     W     /     W     /	|				         /     W     /     W     / |
     /           /           /	|				        /           /           /  |
	o-----------o-----------o   |				   	   o-----------o-----------o   |
   /	       /	       /| R |				      /	          /	          /| R |
  /		W     /	    W     /	|  	o				     /		W    /	    W    / |   o
 /           /	         /	|  /|		   \\	    /           /	        /  |  /|	
o-----------o-----------o   | /	|	  ======	   o-----------o-----------o   | / |	
|           |           |	|/	|		   //      |           |           |   |/  |	
|           |           | R |  	|				   |           |           | R |   |
|     G     |     G     |  /| R |				   |     G     |     G     |  /| G |
|           |           | /	|   o				   |           |           | / |   o
|           |           |/	|  /				   |           |           |/  |  /
o-----------o-----------o   | /					   o-----------o-----------o   | /
|           |           | R |/					   |           |           | G |/
|           |           |   o					   |           |           |   o
|     G     |     G     |  /					   |     O     |     O     |  /
|           |           | /						   |           |           | /
|           |           |/						   |           |           |/
o-----------------------o						   o-----------------------o

*/
-- -----------------------------------------------------------------------------------
-- Diese Funktion nimmt eine Wrfel-ID entgegen, dreht dann genau eine definierte   --
-- Ebene um 90 in die spezifizierte Richtung, generiert eine passende ID und gibt  --
-- die neue Wrfel-ID wieder aus.                                                   --
-- -----------------------------------------------------------------------------------
-- Funktion fr die Drehung der unteren waagerechten Ebene im Uhrzeigersinn         --
-- -----------------------------------------------------------------------------------
CREATE OR ALTER FUNCTION [RubiksCube].[fncDreheUntenRechts] 
(
       @Eingangsposition          AS     VARCHAR(24)
)
RETURNS CHAR(24)
AS
BEGIN
    DECLARE @Rueckgabewert     AS VARCHAR(24) = ''
    SET @Rueckgabewert =                    SUBSTRING ( @Eingangsposition ,  1, 12)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 19,  2)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 13,  6)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 23,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 21,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 24,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 22,  1)
    RETURN @Rueckgabewert
END
GO





/*
        o-----------o-----------o				           o-----------o-----------o
       /           /           /|				          /           /           /|
      /     W     /     W     /	|				         /     W     /     G     / |
     /           /           /	|				        /           /           /  |
	o-----------o-----------o   |				   	   o-----------o-----------o   |
   /	       /	       /| R |				      /	          /	          /| R |
  /		W     /	    W     /	|  	o				     /		W    /	    G    / |   o
 /           /	         /	|  /|		   \\	    /           /	        /  |  /|	
o-----------o-----------o   | /	|	  ======	   o-----------o-----------o   | / |	
|           |           |	|/	|		   //      |           |           |   |/  |	
|           |           | R |  	|				   |           |           | R |   |
|     G     |     G     |  /| R |				   |     G     |     B     |  /| R |
|           |           | /	|   o				   |           |           | / |   o
|           |           |/	|  /				   |           |           |/  |  /
o-----------o-----------o   | /					   o-----------o-----------o   | /
|           |           | R |/					   |           |           | R |/
|           |           |   o					   |           |           |   o
|     G     |     G     |  /					   |     G     |     B     |  /
|           |           | /						   |           |           | /
|           |           |/						   |           |           |/
o-----------------------o						   o-----------------------o

*/
-- -----------------------------------------------------------------------------------
-- Diese Funktion nimmt eine Wrfel-ID entgegen, dreht dann genau eine definierte   --
-- Ebene um 90 in die spezifizierte Richtung, generiert eine passende ID und gibt  --
-- die neue Wrfel-ID wieder aus.                                                   --
-- -----------------------------------------------------------------------------------
-- Funktion fr die Drehung der rechten senkrechten Ebene nach oben                 --
-- -----------------------------------------------------------------------------------
CREATE OR ALTER FUNCTION [RubiksCube].[fncDreheRechtsHoch] 
(
       @Eingangsposition          AS     VARCHAR(24)
)
RETURNS CHAR(24)
AS
BEGIN
    DECLARE @Rueckgabewert     AS VARCHAR(24) = ''
    SET @Rueckgabewert =                    SUBSTRING ( @Eingangsposition ,  1,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  8,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  3,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 16,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  5,  3)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 22,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  9,  2)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  4,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 12,  4)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 24,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 17,  2)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  2,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 20,  2)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 19,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 23,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 11,  1)
    RETURN @Rueckgabewert
END
GO





/*
        o-----------o-----------o				           o-----------o-----------o
       /           /           /|				          /           /           /|
      /     W     /     W     /	|				         /     W     /     Y     / |
     /           /           /	|				        /           /           /  |
	o-----------o-----------o   |				   	   o-----------o-----------o   |
   /	       /	       /| R |				      /	          /	          /| R |
  /		W     /	    W     /	|  	o				     /		W    /	    Y    / |   o
 /           /	         /	|  /|		   \\	    /           /	        /  |  /|	
o-----------o-----------o   | /	|	  ======	   o-----------o-----------o   | / |	
|           |           |	|/	|		   //      |           |           |   |/  |	
|           |           | R |  	|				   |           |           | R |   |
|     G     |     G     |  /| R |				   |     G     |     W     |  /| R |
|           |           | /	|   o				   |           |           | / |   o
|           |           |/	|  /				   |           |           |/  |  /
o-----------o-----------o   | /					   o-----------o-----------o   | /
|           |           | R |/					   |           |           | R |/
|           |           |   o					   |           |           |   o
|     G     |     G     |  /					   |     G     |     W     |  /
|           |           | /						   |           |           | /
|           |           |/						   |           |           |/
o-----------------------o						   o-----------------------o

*/
-- -----------------------------------------------------------------------------------
-- Diese Funktion nimmt eine Wrfel-ID entgegen, dreht dann genau eine definierte   --
-- Ebene um 90 in die spezifizierte Richtung, generiert eine passende ID und gibt  --
-- die neue Wrfel-ID wieder aus.                                                   --
-- -----------------------------------------------------------------------------------
-- Funktion fr die Drehung der rechten senkrechten Ebene nach unten                --
-- -----------------------------------------------------------------------------------
CREATE OR ALTER FUNCTION [RubiksCube].[fncDreheRechtsRunter] 
(
       @Eingangsposition          AS     VARCHAR(24)
)
RETURNS CHAR(24)
AS
BEGIN
    DECLARE @Rueckgabewert     AS VARCHAR(24) = ''
    SET @Rueckgabewert =                    SUBSTRING ( @Eingangsposition ,  1,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 19,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  3,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 11,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  5,  3)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  2,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  9,  2)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 24,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 12,  4)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  4,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 17,  2)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 22,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 20,  2)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  8,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 23,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 16,  1)
    RETURN @Rueckgabewert
END
GO






/*
        o-----------o-----------o				           o-----------o-----------o
       /           /           /|				          /           /           /|
      /     W     /     W     /	|				         /     W     /     W     / |
     /           /           /	|				        /           /           /  |
	o-----------o-----------o   |				   	   o-----------o-----------o   |
   /	       /	       /| R |				      /	          /	          /| R |
  /		W     /	    W     /	|  	o				     /		Y    /	    Y    / |   o
 /           /	         /	|  /|		   \\	    /           /	        /  |  /|	
o-----------o-----------o   | /	|	  ======	   o-----------o-----------o   | / |	
|           |           |	|/	|		   //      |           |           |   |/  |	
|           |           | R |  	|				   |           |           | W |   |
|     G     |     G     |  /| R |				   |     G     |     G     |  /| R |
|           |           | /	|   o				   |           |           | / |   o
|           |           |/	|  /				   |           |           |/  |  /
o-----------o-----------o   | /					   o-----------o-----------o   | /
|           |           | R |/					   |           |           | W |/
|           |           |   o					   |           |           |   o
|     G     |     G     |  /					   |     G     |     G     |  /
|           |           | /						   |           |           | /
|           |           |/						   |           |           |/
o-----------------------o						   o-----------------------o

*/
-- -----------------------------------------------------------------------------------
-- Diese Funktion nimmt eine Wrfel-ID entgegen, dreht dann genau eine definierte   --
-- Ebene um 90 in die spezifizierte Richtung, generiert eine passende ID und gibt  --
-- die neue Wrfel-ID wieder aus.                                                   --
-- -----------------------------------------------------------------------------------
-- Funktion fr die Drehung der vorderen senkrechten Ebene im Uhrzeigersinn         --
-- -----------------------------------------------------------------------------------
CREATE OR ALTER FUNCTION [RubiksCube].[fncDreheVorneRechts] 
(
       @Eingangsposition          AS     VARCHAR(24)
)
RETURNS CHAR(24)
AS
BEGIN
    DECLARE @Rueckgabewert     AS VARCHAR(24) = ''
    SET @Rueckgabewert =                    SUBSTRING ( @Eingangsposition ,  1,  2)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 14,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  6,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  5,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 21,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 15,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  7,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  3,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 10,  4)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 22,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 16,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  8,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  4,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 18,  3)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 17,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  9,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 23,  2)
    RETURN @Rueckgabewert
END
GO





/*
        o-----------o-----------o				           o-----------o-----------o
       /           /           /|				          /           /           /|
      /     W     /     W     /	|				         /     W     /     W     / |
     /           /           /	|				        /           /           /  |
	o-----------o-----------o   |				   	   o-----------o-----------o   |
   /	       /	       /| R |				      /	          /	          /| R |
  /		W     /	    W     /	|  	o				     /		R    /	    R    / |   o
 /           /	         /	|  /|		   \\	    /           /	        /  |  /|	
o-----------o-----------o   | /	|	  ======	   o-----------o-----------o   | / |	
|           |           |	|/	|		   //      |           |           |   |/  |	
|           |           | R |  	|				   |           |           | B |   |
|     G     |     G     |  /| R |				   |     G     |     G     |  /| R |
|           |           | /	|   o				   |           |           | / |   o
|           |           |/	|  /				   |           |           |/  |  /
o-----------o-----------o   | /					   o-----------o-----------o   | /
|           |           | R |/					   |           |           | B |/
|           |           |   o					   |           |           |   o
|     G     |     G     |  /					   |     G     |     G     |  /
|           |           | /						   |           |           | /
|           |           |/						   |           |           |/
o-----------------------o						   o-----------------------o

*/
-- -----------------------------------------------------------------------------------
-- Diese Funktion nimmt eine Wrfel-ID entgegen, dreht dann genau eine definierte   --
-- Ebene um 90 in die spezifizierte Richtung, generiert eine passende ID und gibt  --
-- die neue Wrfel-ID wieder aus.                                                   --
-- -----------------------------------------------------------------------------------
-- Funktion fr die Drehung der vorderen senkrechten Ebene gegen den Uhrzeigersinn  --
-- -----------------------------------------------------------------------------------
CREATE OR ALTER FUNCTION [RubiksCube].[fncDreheVorneLinks] 
(
       @Eingangsposition          AS     VARCHAR(24)
)
RETURNS CHAR(24)
AS
BEGIN
    DECLARE @Rueckgabewert     AS VARCHAR(24) = ''
    SET @Rueckgabewert =                    SUBSTRING ( @Eingangsposition ,  1,  2)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  9,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 17,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  5,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  4,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  8,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 16,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 22,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 10,  4)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  3,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  7,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 15,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 21,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 18,  3)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  6,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 14,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 23,  2)
    RETURN @Rueckgabewert
END
GO





/*
        o-----------o-----------o				           o-----------o-----------o
       /           /           /|				          /           /           /|
      /     W     /     W     /	|				         /     G     /     W     / |
     /           /           /	|				        /           /           /  |
	o-----------o-----------o   |				   	   o-----------o-----------o   |
   /	       /	       /| R |				      /	          /	          /| R |
  /		W     /	    W     /	|  	o				     /		G    /	   W     / |   o
 /           /	         /	|  /|		   \\	    /           /	        /  |  /|	
o-----------o-----------o   | /	|	  ======	   o-----------o-----------o   | / |	
|           |           |	|/	|		   //      |           |           |   |/  |	
|           |           | R |  	|				   |           |           | R |   |
|     G     |     G     |  /| R |				   |     B     |     G     |  /| R |
|           |           | /	|   o				   |           |           | / |   o
|           |           |/	|  /				   |           |           |/  |  /
o-----------o-----------o   | /					   o-----------o-----------o   | /
|           |           | R |/					   |           |           | R |/
|           |           |   o					   |           |           |   o
|     G     |     G     |  /					   |     B     |     G     |  /
|           |           | /						   |           |           | /
|           |           |/						   |           |           |/
o-----------------------o						   o-----------------------o

*/
-- -----------------------------------------------------------------------------------
-- Diese Funktion nimmt eine Wrfel-ID entgegen, dreht dann genau eine definierte   --
-- Ebene um 90 in die spezifizierte Richtung, generiert eine passende ID und gibt  --
-- die neue Wrfel-ID wieder aus.                                                   --
-- -----------------------------------------------------------------------------------
-- Funktion fr die Drehung der linken senkrechten Ebene nach oben                  --
-- -----------------------------------------------------------------------------------
CREATE OR ALTER FUNCTION [RubiksCube].[fncDreheLinksHoch] 
(
       @Eingangsposition          AS     VARCHAR(24)
)
RETURNS CHAR(24)
AS
BEGIN
    DECLARE @Rueckgabewert     AS VARCHAR(24) = ''
    SET @Rueckgabewert =                    SUBSTRING ( @Eingangsposition ,  7,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  2,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 15,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  4,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  6,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 15,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 14,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 21,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  8,  4)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  3,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  5,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 13,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 23,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 16,  4)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  1,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 20,  2)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 12,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 24,  1)
    RETURN @Rueckgabewert
END
GO






/*
        o-----------o-----------o				           o-----------o-----------o
       /           /           /|				          /           /           /|
      /     W     /     W     /	|				         /     Y     /     W     / |
     /           /           /	|				        /           /           /  |
	o-----------o-----------o   |				   	   o-----------o-----------o   |
   /	       /	       /| R |				      /	          /	          /| R |
  /		W     /	    W     /	|  	o				     /	   Y     /	   W     / |   o
 /           /	         /	|  /|		   \\	    /           /	        /  |  /|	
o-----------o-----------o   | /	|	  ======	   o-----------o-----------o   | / |	
|           |           |	|/	|		   //      |           |           |   |/  |	
|           |           | R |  	|				   |           |           | R |   |
|     G     |     G     |  /| R |				   |     W     |     G     |  /| R |
|           |           | /	|   o				   |           |           | / |   o
|           |           |/	|  /				   |           |           |/  |  /
o-----------o-----------o   | /					   o-----------o-----------o   | /
|           |           | R |/					   |           |           | R |/
|           |           |   o					   |           |           |   o
|     G     |     G     |  /					   |     W     |     G     |  /
|           |           | /						   |           |           | /
|           |           |/						   |           |           |/
o-----------------------o						   o-----------------------o

*/
-- -----------------------------------------------------------------------------------
-- Diese Funktion nimmt eine Wrfel-ID entgegen, dreht dann genau eine definierte   --
-- Ebene um 90 in die spezifizierte Richtung, generiert eine passende ID und gibt  --
-- die neue Wrfel-ID wieder aus.                                                   --
-- -----------------------------------------------------------------------------------
-- Funktion fr die Drehung der linken senkrechten Ebene nach unten                 --
-- -----------------------------------------------------------------------------------
CREATE OR ALTER FUNCTION [RubiksCube].[fncDreheLinksRunter] 
(
       @Eingangsposition          AS     VARCHAR(24)
)
RETURNS CHAR(24)
AS
BEGIN
    DECLARE @Rueckgabewert     AS VARCHAR(24) = ''
    SET @Rueckgabewert =                    SUBSTRING ( @Eingangsposition , 20,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  2,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 12,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  4,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 13,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  5,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  1,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  8,  4)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 23,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 14,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  5,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  3,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 16,  4)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 21,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  7,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 22,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 15,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 24,  1)
    RETURN @Rueckgabewert
END
GO






/*
        o-----------o-----------o				           o-----------o-----------o
       /           /           /|				          /           /           /|
      /     W     /     W     /	|				         /     R     /     R     / |
     /           /           /	|				        /           /           /  |
	o-----------o-----------o   |				   	   o-----------o-----------o   |
   /	       /	       /| R |				      /	          /	          /| B |
  /		W     /	    W     /	|  	o				     /	   W     /	   W     / |   o
 /           /	         /	|  /|		   \\	    /           /	        /  |  /|	
o-----------o-----------o   | /	|	  ======	   o-----------o-----------o   | / |	
|           |           |	|/	|		   //      |           |           |   |/  |	
|           |           | R |  	|				   |           |           | R |   |
|     G     |     G     |  /| R |				   |     G     |     G     |  /| B |
|           |           | /	|   o				   |           |           | / |   o
|           |           |/	|  /				   |           |           |/  |  /
o-----------o-----------o   | /					   o-----------o-----------o   | /
|           |           | R |/					   |           |           | R |/
|           |           |   o					   |           |           |   o
|     G     |     G     |  /					   |     G     |     G     |  /
|           |           | /						   |           |           | /
|           |           |/						   |           |           |/
o-----------------------o						   o-----------------------o

*/

-- -----------------------------------------------------------------------------------
-- Diese Funktion nimmt eine Wrfel-ID entgegen, dreht dann genau eine definierte   --
-- Ebene um 90 in die spezifizierte Richtung, generiert eine passende ID und gibt  --
-- die neue Wrfel-ID wieder aus.                                                   --
-- -----------------------------------------------------------------------------------
-- Funktion fr die Drehung der hinteren senkrechten Ebene gegen den Uhrzeigersinn  --
-- -----------------------------------------------------------------------------------
CREATE OR ALTER FUNCTION [RubiksCube].[fncDreheHintenLinks] 
(
       @Eingangsposition          AS     VARCHAR(24)
)
RETURNS CHAR(24)
AS
BEGIN
    DECLARE @Rueckgabewert     AS VARCHAR(24) = ''
    SET @Rueckgabewert =                    SUBSTRING ( @Eingangsposition , 10,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 18,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  3,  2)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  2,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  6,  4)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 24,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 19,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 11,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  1,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 14,  4)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 23,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 20,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 12,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 21,  2)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  5,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 13,  1)
    RETURN @Rueckgabewert
END
GO





/*
        o-----------o-----------o				           o-----------o-----------o
       /           /           /|				          /           /           /|
      /     W     /     W     /	|				         /     O     /     O     / |
     /           /           /	|				        /           /           /  |
	o-----------o-----------o   |				   	   o-----------o-----------o   |
   /	       /	       /| R |				      /	          /	          /| W |
  /		W     /	    W     /	|  	o				     /	   W     /	   W     / |   o
 /           /	         /	|  /|		   \\	    /           /	        /  |  /|	
o-----------o-----------o   | /	|	  ======	   o-----------o-----------o   | / |	
|           |           |	|/	|		   //      |           |           |   |/  |	
|           |           | R |  	|				   |           |           | R |   |
|     G     |     G     |  /| R |				   |     G     |     G     |  /| W |
|           |           | /	|   o				   |           |           | / |   o
|           |           |/	|  /				   |           |           |/  |  /
o-----------o-----------o   | /					   o-----------o-----------o   | /
|           |           | R |/					   |           |           | R |/
|           |           |   o					   |           |           |   o
|     G     |     G     |  /					   |     G     |     G     |  /
|           |           | /						   |           |           | /
|           |           |/						   |           |           |/
o-----------------------o						   o-----------------------o

*/

-- -----------------------------------------------------------------------------------
-- Diese Funktion nimmt eine Wrfel-ID entgegen, dreht dann genau eine definierte   --
-- Ebene um 90 in die spezifizierte Richtung, generiert eine passende ID und gibt  --
-- die neue Wrfel-ID wieder aus.                                                   --
-- -----------------------------------------------------------------------------------
-- Funktion fr die Drehung der hinteren senkrechten Ebene im Uhrzeigersinn         --
-- -----------------------------------------------------------------------------------
CREATE OR ALTER FUNCTION [RubiksCube].[fncDreheHintenRechts] 
(
       @Eingangsposition          AS     VARCHAR(24)
)
RETURNS CHAR(24)
AS
BEGIN
    DECLARE @Rueckgabewert     AS VARCHAR(24) = ''
    SET @Rueckgabewert =                    SUBSTRING ( @Eingangsposition , 13,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  5,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  3,  2)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 23,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  6,  4)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  1,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 20,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 19,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 24,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 14,  4)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition ,  2,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 12,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 11,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 21,  2)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 18,  1)
    SET @Rueckgabewert = @Rueckgabewert +   SUBSTRING ( @Eingangsposition , 10,  1)
    RETURN @Rueckgabewert
END
GO