-- #####################################################################################
-- ## Skript zum Vortrag <die schwierigen Kopfnsse mit T-SQL gelst>                 ##     
-- #####################################################################################
-- ## Dieses Skript legt die Tabellen fr die Aufgabe "RubiksCube" an. Es wird durch  ##
-- ## weitere Skripte ergnzt, die in ihrer durchnummerierten Reihenfolge abzu-       ##
-- ## arbeiten sind. Die Skripte passen zu den Ausfhrungen aus der zugehrigen       ##
-- ## Powerpoint-Prsentation vom selben Autor.                                       ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Bitte dieses Skript niemals in einer Produktionsumgebung einsetzen, da          ##
-- ## Datenbankobjekte angelegt, ergnzt, gendert oder sogar gelscht werden!!!      ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Verwendung auf eigene Gefahr...                                                 ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Torsten Ahlemeyer, arelium GmbH        torsten.ahlemeyer@arelium.de             ##
-- #####################################################################################

-- auf die Projektdatenbank wechseln
USE [Workshop_Kopfnuesse]
GO

SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO



-- Installation einer "herkmmlichen" Prozedur, die zu Fu eine Rekursion 
-- aufbaut, um eine Lsung zu finden
CREATE OR ALTER PROCEDURE [RubiksCube].[prcRekursiveLoesung]
	  @Start				CHAR(24)
	, @Ziel					CHAR(24)
AS
BEGIN
	SET NOCOUNT ON;
;WITH loopquery
(
	  [Start]
	, [Drehung]
	, [Ziel]
	, [Zugzahl]
) 
AS (
	-- Initialisierung der Rekursion
	SELECT
		  [Zug].[Ausgangsposition]						AS [Start]
		, CONVERT(VARCHAR(MAX), [Zug].[Bewegung])		AS [Drehung]
		, [Zug].[Zielposition]							AS [Ziel]
		, 1												AS [Zugzahl]
	FROM [RubiksCube].[ZugKombinationen]				AS [Zug]
	WHERE [Zug].[Ausgangsposition] = @Start
	
	UNION ALL
	
	-- Rekursion 
	SELECT 
		  [p].[Ausgangsposition]
		, CAST([lq].[Ziel] + ', ' + [p].[Zielposition]	AS VARCHAR(MAX))
		, [p].[Zielposition]
		, [Zugzahl] + 1
	FROM loopquery										AS [lq]
	INNER JOIN [RubiksCube].[ZugKombinationen]			AS [p] 
		ON [p].[Ausgangsposition] = [lq].[Ziel]
	WHERE 1 = 1
		-- Abbruchbedingung der Rekursion
		AND [lq].[Ziel]		<> @Ziel
		AND [lq].[Zugzahl]	< 21			   -- 20 ist die magische Zahl (alle Wrfel sind mit max. 20 Verdrehungen lsbar)
	)

	-- Ausgabe des Ergebnisses
	SELECT TOP 1
		  [lq].[Start]									AS [Start]
		, [lq].[Drehung]								AS [Drehung]
		, [lq].[Ziel]									AS [Ziel]
		, [lq].[Zugzahl]
	FROM loopquery AS [lq]
	END
GO



/*
USE [Workshop_Kopfnuesse]
GO

DECLARE @RC int
DECLARE @Start char(24)
DECLARE @Ziel char(24)

SET @Start	= 'WWWWGGRRBBOOGGRRBBOOYYYY'
SET @Ziel	= 'GORWORGYGRWOWYYBRBWBGBYO'

EXECUTE @RC = [RubiksCube].[prcRekursiveLoesung] 
   @Start
  ,@Ziel
GO
*/