-- #####################################################################################
-- ## Skript zum Vortrag <die schwierigen Kopfnsse mit T-SQL gelst>                 ##     
-- #####################################################################################
-- ## Dieses Skript legt die Tabellen fr die Aufgabe EINSTEIN an. Es wird durch      ##
-- ## weitere Skripte ergnzt, die in ihrer durchnummerierten Reihenfolge abzu-       ##
-- ## arbeiten sind. Die Skripte passen zu den Ausfhrungen aus der zugehrigen       ##
-- ## Powerpoint-Prsentation vom selben Autor.                                       ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Bitte dieses Skript niemals in einer Produktionsumgebung einsetzen, da          ##
-- ## Datenbankobjekte angelegt, ergnzt, gendert oder sogar gelscht werden!!!      ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Verwendung auf eigene Gefahr...                                                 ##
-- ## ------------------------------------------------------------------------------- ##
-- ## Torsten Ahlemeyer, arelium GmbH        torsten.ahlemeyer@arelium.de             ##
-- #####################################################################################

-- auf die Projektdatenbank wechseln
USE [Workshop_Kopfnuesse]
GO

SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO


--SET @Start	= 'BBOORRGGYYWWBBRRYYWWOOGG'
--SET @Ziel	= 'BBOORRGGYYWWBBRRYYWWOOGG'

CREATE OR ALTER PROCEDURE [RubiksCube].[prcGraphLoesung]
	  @Start	CHAR(24)
	, @Ziel		CHAR(24)
AS
BEGIN
	SET NOCOUNT ON;

	SELECT 
		  [innen].[Startposition]				AS [Startposition]
		, [innen].[Drehungen]					AS [Drehung]
		, [innen].[Zielposition]				AS [Zielposition]
	FROM
		(
			SELECT 
				  [Start].[PositionID]											AS [Startposition]
				, STRING_AGG([dn].[Drehung], '->')	WITHIN GROUP (GRAPH PATH)	AS [Drehungen]
				, LAST_VALUE([Ziel].[PositionID])	WITHIN GROUP (GRAPH PATH)	AS [Zielposition]
			FROM 
				  [RubiksCube].[Position]					AS [Start]
				, [RubiksCube].[dreht_nach]		FOR PATH	AS [dn]
				, [RubiksCube].[Position]		FOR PATH	AS [Ziel]
			WHERE MATCH(SHORTEST_PATH([Start](-([dn])->[Ziel])+))
			AND [Start].[PositionID] = @Start
		) AS [innen]
	WHERE [innen].[Zielposition] = @Ziel
END
GO






/*
DECLARE	@return_value int

EXEC	@return_value = [RubiksCube].[prcGraphLoesung]
		@Start = N'BBOORRGGYYWWBBRRYYWWOOGG',
		@Ziel = N'BBOORRGGYYWWBBRRYYWWOOGG'

SELECT	'Return Value' = @return_value
*/




